import { world, system, ItemStack } from '@minecraft/server'

// Todos los trinkets deben ser registrados en las listas, se puede usar la misma, pero aqui lo separe para organizar mejor

// Slots: Head, Body, Feet, Necklace, Ring, Charm, Gauntlet, Talisman, Hearty Charm, Doll, Wither Ring, Archaic Charm
// Abilities: ['health', 'speed', 'attack', 'waterSpeed', 'magicD'];

// const initialValues = {
//         health: 20,       // Valor inicial de vida
//         speed: 0.1,         // Valor inicial de velocidad
//         attack: 1,        // Valor inicial de ataque
//         waterSpeed: 0.02,    // Velocidad en agua
//         magicD: 1,   // Protección mágica
//     };

const doriosTrinkets = [
    // Hearty Charm
    { identifier: "twm:rotten_heart", slot: 'heartycharm', health: 2 }, // Zombie 5%
    { identifier: "twm:candy_heart", slot: 'heartycharm', health: 4 }, // Witch 5%
    { identifier: `twm:soul_heart`, slot: 'heartycharm', health: 8 }, // Ancient City 10%
    { identifier: "twm:immaculate_heart", slot: 'heartycharm', health: 10, attack: 1 }, // Desert Pyramid 5%
    { identifier: `twm:black_heart`, slot: 'heartycharm', health: 6 }, // Enderman 5%
    { identifier: `twm:eternal_heart`, slot: 'heartycharm', health: 8 }, // Ancient City 5%
    { identifier: "twm:sacred_heart", slot: 'heartycharm', health: 20 }, // Desert Pyramid 2%
    { identifier: `twm:warden_heart`, slot: 'heartycharm', health: 16, magicD: -0.25 }, // Crafted
    { identifier: `twm:wither_heart`, slot: 'heartycharm', health: 16 }, // Wither 5%

    // Feet
    { identifier: `twm:cloud_steps_boots`, slot: 'feet', speed: 0.03 }, // Phantom 5%
    { identifier: "twm:lava_waders", slot: 'feet', speed: 0.02 }, // Strider 5%

    // Charm
    // Abyssal Set
    { identifier: `twm:dead_abyssal_orb`, slot: 'charm', waterSpeed: 0.006 }, // Buried Treasure & Underwater Ruin 25%
    { identifier: `twm:abyssal_clam_shell`, slot: 'talisman', waterSpeed: 0.01 }, // Underwater Ruin 10%
    { identifier: `twm:abyssal_orb`, slot: 'charm', waterSpeed: 0.02 }, // Crafted
    { identifier: `twm:abyssal_essence`, slot: 'archaiccharm', waterSpeed: 0.04 }, // Underwater Ruin 2%
    { identifier: `twm:abyssal_diver_helmet`, slot: 'head', waterSpeed: 0.004 }, //Shipwreck Treasure 20%
    // Normal
    { identifier: "twm:obsidian_skull", slot: 'charm' }, // Crafted
    { identifier: "twm:purity_blossom", slot: 'charm' }, // Witch 5%

    //Gauntlet
    { identifier: "twm:fire_gauntlet", slot: 'gauntlet' }, // Netherfortress 20%
    { identifier: `twm:ice_gauntlet`, slot: 'gauntlet' }, // Igloo 25%
    { identifier: `twm:venom_gauntlet`, slot: 'gauntlet' }, // Jungle Temple 50%
    { identifier: `twm:fire_claw`, slot: 'gauntlet', attack: 2 }, // Netherfortress 5%
    { identifier: `twm:venom_claw`, slot: 'gauntlet', attack: 2 },// Jungle Temple 20%
    { identifier: `twm:ice_claw`, slot: 'gauntlet', attack: 2 },// Igloo 10%

    // Head
    { identifier: "twm:night_vision_mask", slot: 'head' }, // Stronghold 10%
    { identifier: "twm:night_vision_goggles", slot: 'head' }, // Crafted
    { identifier: `twm:broken_paladin_helmet`, slot: 'head', attack: 1 }, // Ruined Portal 10%
    { identifier: `twm:restored_paladin_helmet`, slot: 'head', attack: 3 }, // End City 5% & Crafted

    // Necklace
    { identifier: "twm:rush_of_fear", slot: 'necklace', health: 4 }, // Desert Pyramid 15%
    { identifier: `twm:repair_talisman`, slot: 'necklace' }, // Blacksmith 20%
    { identifier: `twm:mender_pendant`, slot: 'necklace' }, // Desert Pyramid 10%
    { identifier: `twm:blood_pendant`, slot: 'necklace', health: 4 }, // Ruined Portal 10%
    { identifier: `twm:rabbit_rush`, slot: 'necklace', speed: 0.02 }, // Rabits 25%

    // Ring
    { identifier: `twm:guardian_ring`, slot: 'ring' }, // Crafted
    { identifier: `twm:runner_ring`, slot: 'ring' }, // Crafted
    { identifier: `twm:healer_ring`, slot: 'ring' }, // Crafted
    { identifier: `twm:miner_ring`, slot: 'ring' }, // Crafted
    { identifier: `twm:warrior_ring`, slot: 'ring', attack: 2 }, // Vindicators 5%

    // Wither Ring
    { identifier: `twm:heavy_guardian_ring`, slot: 'witherring' }, // Desert Pyramid 5%
    { identifier: `twm:heavy_runner_ring`, slot: 'witherring' }, // Desert Pyramid 5%
    { identifier: `twm:heavy_healer_ring`, slot: 'witherring' }, // Desert Pyramid 5%
    { identifier: `twm:heavy_miner_ring`, slot: 'witherring' }, // Desert Pyramid 5%
    { identifier: `twm:heavy_warrior_ring`, slot: 'witherring' }, // Desert Pyramid 5%

    // Body
    { identifier: "twm:molten_quiver", slot: 'body' }, // Nether Skeletons 5%
    { identifier: `twm:frost_quiver`, slot: 'body' }, // Strays 10%
    { identifier: `twm:venom_quiver`, slot: 'body' }, // Jungle Temple 30%
    { identifier: `twm:idle_bloom`, slot: 'body' }, // Jungle Temple 10%

    // Archaic Charm
    { identifier: `twm:blood_pact`, slot: 'archaiccharm', health: -20 }, // Bastion Treasure 10%

    // Talisman
    { identifier: `twm:holy_cross`, slot: 'talisman' }, // Desert Pyramid 10%
    { identifier: `twm:bloodbound_amulet`, slot: 'talisman', health: 6 } // Bastion Treasure 20%


]

// Se deben de agregar todos, este define que sean equipables. Su funcion se define en mas adelante
const archaismTrinkets = [
    { identifier: "arena:ethereal_sight_mask", slot: 'head', attack: 1 },
    { identifier: "arena:fox_mask", slot: 'head', speed: 0.02, health: -6 },
    { identifier: "arena:blaze_skull_mask", slot: 'head' },
    { identifier: "arena:marble_mask", slot: 'head', health: 12 },
    { identifier: "arena:poseidon_mask", slot: 'head', waterSpeed: 0.006 },
    { identifier: "arena:kitsume_mask", slot: 'head', health: -18 },
    { identifier: "arena:natural_butterfly_mask", slot: 'head', speed: 0.01 },
    { identifier: "arena:unnatural_mask", slot: 'head', attack: 3 },
    { identifier: "arena:demon_mask", slot: 'head', health: 4 },
    { identifier: "arena:cat_mask", slot: 'head', health: -2 },
    // Jewerly
    // Rings
    { identifier: "arena:amethyst_earring_jelewer", slot: 'ring' },
    { identifier: "arena:crimsom_earring_jelewer", slot: 'ring' },
    { identifier: "arena:crimsom_amethyst_earring_jelewer", slot: 'ring' },

    { identifier: 'arena:withered_ring_jelewer', slot: 'ring' },
    { identifier: 'arena:silk_ring_jelewer', slot: 'ring' },
    { identifier: 'arena:shulked_ring_jelewer', slot: 'ring' },
    { identifier: 'arena:shadow_step_ring_jelewer', slot: 'ring' },
    { identifier: 'arena:obsidian_ring_jelewer', slot: 'ring' },
    { identifier: 'arena:crimson_ring_jelewer', slot: 'ring' },
    { identifier: 'arena:crimsom_amethyst_ring_jelewer', slot: 'ring' },
    { identifier: 'arena:blinding_of_shinning_ring_jelewer', slot: 'ring' },
    // Necklace
    { identifier: 'arena:iron_end_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:iron_fire_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:iron_light_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:iron_poison_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:iron_snow_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:golden_end_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:golden_fire_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:golden_light_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:golden_poison_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:golden_snow_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:prismarine_end_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:prismarine_fire_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:prismarine_light_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:prismarine_poison_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:prismarine_snow_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:netherite_end_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:netherite_fire_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:netherite_light_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:netherite_poison_necklace_jelewer', slot: 'necklace' },
    { identifier: 'arena:netherite_snow_necklace_jelewer', slot: 'necklace' },
    // Crowns
    { identifier: 'arena:iron_crown_jelewer', slot: 'head' },
    { identifier: 'arena:golden_crown_jelewer', slot: 'head' },
    { identifier: 'arena:prismarine_crown_jelewer', slot: 'head' },
    { identifier: 'arena:netherite_crown_jelewer', slot: 'head' },
    // Wither Rings
    { identifier: 'arena:jump_copper_wither_ring', slot: 'witherring' },
    { identifier: 'arena:damage_copper_wither_ring', slot: 'witherring', attack: 1, health: -8 },
    { identifier: 'arena:movement_copper_wither_ring', slot: 'witherring', speed: 0.01, attack: -1 },
    { identifier: 'arena:hearts_copper_wither_ring', slot: 'witherring', health: 6 },
    { identifier: 'arena:swiming_copper_wither_ring', slot: 'witherring', waterSpeed: 0.004 },
    { identifier: 'arena:jump_iron_wither_ring', slot: 'witherring' },
    { identifier: 'arena:damage_iron_wither_ring', slot: 'witherring', attack: 2, health: -16 },
    { identifier: 'arena:movement_iron_wither_ring', slot: 'witherring', speed: 0.006, attack: -2 },
    { identifier: 'arena:hearts_iron_wither_ring', slot: 'witherring', health: 12 },
    { identifier: 'arena:swiming_iron_wither_ring', slot: 'witherring', waterSpeed: 0.02 },
    { identifier: 'arena:jump_golden_wither_ring', slot: 'witherring' },
    { identifier: 'arena:damage_golden_wither_ring', slot: 'witherring', attack: 3, health: -24 },
    { identifier: 'arena:movement_golden_wither_ring', slot: 'witherring', speed: 0.008, attack: -2 },
    { identifier: 'arena:hearts_golden_wither_ring', slot: 'witherring', health: 18 },
    { identifier: 'arena:swiming_golden_wither_ring', slot: 'witherring', waterSpeed: 0.025 },
    { identifier: 'arena:jump_prismarine_wither_ring', slot: 'witherring' },
    { identifier: 'arena:damage_prismarine_wither_ring', slot: 'witherring', attack: 4, health: -32 },
    { identifier: 'arena:movement_prismarine_wither_ring', slot: 'witherring', speed: 0.04, attack: -2 },
    { identifier: 'arena:hearts_prismarine_wither_ring', slot: 'witherring', health: 24 },
    { identifier: 'arena:swiming_prismarine_wither_ring', slot: 'witherring', waterSpeed: 0.010 },
    // Talismans
    { identifier: 'arena:nefrite_bracelet_talisman', slot: 'talisman' },
    { identifier: 'arena:night_vision_gogles_talisman', slot: 'talisman' },
    { identifier: 'arena:obsidian_eye_talisman', slot: 'talisman' },
    { identifier: 'arena:obsidian_skull_talisman', slot: 'talisman' },
    { identifier: 'arena:rabbit_boots_talisman', slot: 'talisman' },
    { identifier: 'arena:rhetoric_skull', slot: 'talisman', attack: 1 },
    { identifier: 'arena:shadow_of_nobody_talisman', slot: 'talisman' },
    { identifier: 'arena:chained_heart_talisman', slot: 'talisman', health: 2 },
    { identifier: 'arena:blessed_necklace_talisman', slot: 'talisman' },
    { identifier: 'arena:death_skull_talisman', slot: 'talisman' },
    { identifier: 'arena:hermes_boots_talisman', slot: 'talisman' },
    { identifier: 'arena:magnet_talisman', slot: 'talisman' },
    { identifier: 'arena:marble_emerald_necklace_talisman', slot: 'talisman' },
    { identifier: 'arena:marble_feather_talisman', slot: 'talisman' },
    { identifier: 'arena:nautilus_star_necklace_talisman', slot: 'talisman', waterSpeed: 0.004 },
    // Dolls
    { identifier: 'arena:aplpha_doll', slot: 'doll' },
    { identifier: 'arena:bee_doll', slot: 'doll', speed: 0.01 },
    { identifier: 'arena:doll_doll', slot: 'doll' },
    { identifier: 'arena:fire_doll', slot: 'doll', health: -4 },
    { identifier: 'arena:gentrix_doll', slot: 'doll', waterSpeed: 0.002 },
    { identifier: 'arena:harena_doll', slot: 'doll', health: 4 },
    { identifier: 'arena:illuminated_doll', slot: 'doll' },
    { identifier: 'arena:jesus_doll', slot: 'doll' },
    { identifier: 'arena:masked_doll', slot: 'doll' },
    { identifier: 'arena:shulked_doll', slot: 'doll', attack: 1 },
    { identifier: 'arena:vulak_doll', slot: 'doll' },
    { identifier: 'arena:zultinus_doll', slot: 'doll', speed: -0.01 },
    // Archaic charm
    { identifier: 'arena:archaic_arnold', slot: 'archaiccharm' },
    { identifier: 'arena:archaic_blessed_shield', slot: 'archaiccharm', speed: -0.02 },
    { identifier: 'arena:archaic_chained_soul', slot: 'archaiccharm' },
    { identifier: 'arena:archaic_cursed_book', slot: 'archaiccharm', speed: -0.03 },
    { identifier: 'arena:archaic_cursed_skull', slot: 'archaiccharm', attack: 4, health: -30 },
    { identifier: 'arena:archaic_incript_paper', slot: 'archaiccharm' },
    { identifier: 'arena:archaic_light_cepter', slot: 'archaiccharm' },
    { identifier: 'arena:archaic_marble_bracelets', slot: 'archaiccharm', attack: 2 },
    { identifier: 'arena:archaic_marble_wings', slot: 'archaiccharm', health: 20 },
    // Charms
    { identifier: 'arena:blessed_skull_charm', slot: 'charm' },
    { identifier: 'arena:demon_heart_charm', slot: 'charm', health: 20 },
    { identifier: 'arena:marble_hand_charm', slot: 'charm', attack: 2 },
    { identifier: 'arena:marble_rune_charm', slot: 'charm', speed: 0.02 },
    { identifier: 'arena:nefrite_crow_charm', slot: 'charm' },
    { identifier: 'arena:night_hood_charm', slot: 'charm' },
    { identifier: 'arena:piglin_bracelet_charm', slot: 'charm', attack: 1 },
    { identifier: 'arena:prismatic_relic_charm', slot: 'charm' },
    { identifier: 'arena:doble_edged', slot: 'charm' },
    //artifacts plus+
    //feet
    { identifier: 'arena:bunny_hoppers', slot: 'feet' },
    { identifier: 'arena:flippers', slot: 'feet', waterSpeed: 0.004 },
    { identifier: 'arena:hermes_boots', slot: 'feet', speed: 0.01 },
    { identifier: 'arena:running_shoes', slot: 'feet' },
    { identifier: 'arena:steadfast_spikes', slot: 'feet' },
    { identifier: 'arena:kitty_slippers', slot: 'feet', attack: 1 },
    //hand
    { identifier: 'arena:digging_claws', slot: 'gauntlet' },
    { identifier: 'arena:fire_gauntlet', slot: 'gauntlet' },
    { identifier: 'arena:golden_hook', slot: 'gauntlet' },
    { identifier: 'arena:power_glove', slot: 'gauntlet', attack: 1 },
    { identifier: 'arena:umbrella', slot: 'gauntlet' },
    { identifier: 'arena:vampic_glove', slot: 'gauntlet' },
    //heartyharm
    { identifier: 'arena:crystal_heart', slot: 'heartycharm', health: 6 },
    //talisman
    { identifier: 'arena:a_obsidian_skull', slot: 'talisman' },
    //body
    { identifier: 'arena:flamingo', slot: 'body', waterSpeed: 0.006 },
    //necklace
    { identifier: 'arena:cross_necklace', slot: 'necklace' },
    { identifier: 'arena:flame_pendant', slot: 'necklace' },
    { identifier: 'arena:lucky_scarf', slot: 'necklace' },
    { identifier: 'arena:regeneration_necklace', slot: 'necklace' },
    { identifier: 'arena:light_necklace', slot: 'necklace' },
    { identifier: 'arena:scarf_of_invisibility', slot: 'necklace' },
    { identifier: 'arena:thorn_pendant', slot: 'necklace' },
    //head
    { identifier: 'arena:n_drink_hat', slot: 'head' },
    { identifier: 'arena:a_night_vision_goggles', slot: 'head' },
    { identifier: 'arena:p_drink_hat', slot: 'head' },
    { identifier: 'arena:snorkel', slot: 'head' },
    { identifier: 'arena:villager_hat', slot: 'head' },
    //terraria trinkets
    //head
    { identifier: 'arena:blindfold', slot: 'head' },
    { identifier: 'arena:bonnet', slot: 'head' },
    { identifier: 'arena:phantom_eye', slot: 'head' },
    { identifier: 'arena:midnight_skull', slot: 'head' },
    //feet
    { identifier: 'arena:aglet', slot: 'feet', speed: 0.02 },
    { identifier: 'arena:anklet_of_the_wind', slot: 'feet', speed: 0.04 },
    { identifier: 'arena:dunerider_boots', slot: 'feet' },
    { identifier: 'arena:ice_skates', slot: 'feet' },
    { identifier: 'arena:frog_leg', slot: 'feet' },
    { identifier: 'arena:frog_flipper', slot: 'feet', waterSpeed: 0.002 },
    { identifier: 'arena:flower_boots', slot: 'feet' },
    { identifier: 'arena:lucky_horseshoe', slot: 'feet' },
    { identifier: 'arena:obsidian_horseshoe', slot: 'feet' },
    //hand
    { identifier: 'arena:band_of_regeneration', slot: 'gauntlet' },
    { identifier: 'arena:ancient_chisel', slot: 'gauntlet' },
    { identifier: 'arena:feral_claws', slot: 'gauntlet', attack: 1 },
    { identifier: 'arena:handwarmer', slot: 'gauntlet' },
    { identifier: 'arena:shackle', slot: 'gauntlet' },
    { identifier: 'arena:shiny_red_balloon', slot: 'gauntlet' },
    { identifier: 'arena:lucky_horseshoe_balloon', slot: 'gauntlet' },
    { identifier: 'arena:obsidian_horseshoe_balloon', slot: 'gauntlet' },
    //ring
    { identifier: 'arena:valentine_ring', slot: 'ring', health: 4 },
    //body
    { identifier: 'arena:jellyfish_necklace', slot: 'necklace' },
    { identifier: 'arena:magiluminescence', slot: 'body', speed: 0.01 },
    //talisman
    { identifier: 'arena:bezoar', slot: 'talisman' },
    { identifier: 'arena:adhesive_bandage', slot: 'talisman' },
    { identifier: 'arena:fast_clock', slot: 'talisman' },
    { identifier: 'arena:chorus_heart', slot: 'talisman' },
    { identifier: 'arena:forbidden_fruit', slot: 'talisman' },
    { identifier: 'arena:vitamins', slot: 'talisman' },
    { identifier: 'arena:medicated_bandage', slot: 'talisman' },
    { identifier: 'arena:chorus_clock', slot: 'talisman' },
    //charm
    { identifier: 'arena:discount_card', slot: 'charm' },
    { identifier: 'arena:neptunes_shell', slot: 'charm', waterSpeed: 0.004 },
    { identifier: 'arena:cobalt_shield', slot: 'charm' },
    { identifier: 'arena:obsidian_shield', slot: 'charm' },
    //archaiccharm
    { identifier: 'arena:ankh_charm', slot: 'archaiccharm' },
    { identifier: 'arena:ankh_shield', slot: 'archaiccharm' }
]


// Se juntan ambas listas en una sola
const trinkets = doriosTrinkets.concat(archaismTrinkets)
// Para agregar otra seria asi (archaismTtrinkets,ejemploTrinkets)

//////////////////////////////////////////////////////////////////// De aqui en adelante van los buffos

// Aqui va todo lo que ejecutara un evento en el jugador, como las mascaras (Mucho cuidado con estos por que el player jala medio raro, de preferencia solo 1 slot que cambie evento)
const eventPlayer = {
    'arena:ethereal_sight_mask_head': {
        on: ['minecraft:event_mask1', 'minecraft:event_mask1_utils_on'],
        off: ['minecraft:event_mask1_utils_off', 'minecraft:event_mask0']
    },
    'arena:fox_mask_head': {
        on: ['minecraft:event_mask2', 'minecraft:event_mask2_utils_on'],
        off: ['minecraft:event_mask2_utils_off', 'minecraft:event_mask0']
    },
    'arena:blaze_skull_mask_head': {
        on: ['minecraft:event_mask3', 'minecraft:event_firei_on'],
        off: ['minecraft:event_firei_off', 'minecraft:event_mask0']
    },
    'arena:marble_mask_head': {
        on: ['minecraft:event_mask4', 'minecraft:event_mask4_utils_on'],
        off: ['minecraft:event_mask4_utils_off', 'minecraft:event_mask0']
    },
    'arena:poseidon_mask_head': {
        on: ['minecraft:event_mask5'],
        off: ['minecraft:event_mask0']
    },
    'arena:kitsume_mask_head': {
        on: ['minecraft:event_mask6'],
        off: ['minecraft:event_mask0']
    },
    'arena:natural_butterfly_mask_head': {
        on: ['minecraft:event_mask7'],
        off: ['minecraft:event_mask0']
    },
    'arena:unnatural_mask_head': {
        on: ['minecraft:event_mask8'],
        off: ['minecraft:event_mask0']
    },
    'arena:demon_mask_head': {
        on: ['minecraft:event_mask9', 'minecraft:event_mask9_all_on', 'minecraft:event_burns_on'],
        off: ['minecraft:event_mask9_all_off', 'minecraft:event_mask0', 'minecraft:event_burns_off', 'minecraft:mask9_timer_off']
    },
    'arena:cat_mask_head': {
        on: ['minecraft:event_mask10', 'minecraft:event_mask10_utils_on'],
        off: ['minecraft:event_mask10_utils_off', 'minecraft:event_mask0']
    },
    //Extras- artifats
    'arena:steadfast_spikes_feet': {
        on: ['minecraft:event_knockback_spike'],
        off: ['minecraft:event_knockback_normal']
    },
    'arena:flamingo_body': {
        on: ['minecraft:event_float_on_water_on'],
        off: ['minecraft:event_float_on_water_off']
    }
};



// Efectos que recibe el jugador pasivamente (se ejecuta cada 2.5 segundos para no tener lag)
world.afterEvents.worldInitialize.subscribe(() => {
    system.runInterval(() => {
        let start = Date.now()
        // We obtain all the players 
        let players = world.getAllPlayers()
        players.forEach(player => {

            // We obtain both blocks where the player is
            const feetBlock = player.dimension?.getBlock(player.location);
            const headBlock = player.dimension?.getBlock(player.location)?.above(1);

            // Effects list
            // effect: is the name of the effect
            // condition: if it needs an external condition or even having another tag (for doing sets)
            // If the trinket doesnt need any conditions, write 1 or True
            // level: the level of the given effect

            // Tag = item identifier + slot
            const passiveEffects = {
                'twm:night_vision_goggles_head': [
                    { effect: 'night_vision', level: 1, effectTime: 330, condition: 1 }
                ],
                'twm:night_vision_mask_head': [
                    { effect: 'night_vision', level: 1, effectTime: 330, condition: 1 }
                ],
                'twm:obsidian_skull_charm': [
                    { effect: 'fire_resistance', level: 1, effectTime: 330, condition: !headBlock?.typeId.includes('lava') && !feetBlock?.typeId.includes('lava') }
                ],
                'twm:abyssal_diver_helmet_head': [
                    { effect: 'water_breathing', level: 1, effectTime: 330, condition: 1 }
                ],
                'twm:abyssal_orb_charm': [
                    { effect: 'conduit_power', level: 1, effectTime: 330, condition: 1 }
                ],
                'twm:abyssal_essence_archaiccharm': [
                    { effect: 'conduit_power', level: 1, effectTime: 330, condition: 1 },
                    { effect: 'strength', level: 2, effectTime: 330, condition: headBlock.typeId.includes('water') && feetBlock?.typeId.includes('water') }
                ],
                'twm:guardian_ring_ring': [
                    { effect: 'resistance', level: 1, effectTime: 330, condition: 1 }
                ],
                'twm:runner_ring_ring': [
                    { effect: 'speed', level: 1, effectTime: 330, condition: 1 }
                ],
                'twm:healer_ring_ring': [
                    { effect: 'regeneration', level: 1, effectTime: 330, condition: 1 }
                ],
                'twm:miner_ring_ring': [
                    { effect: 'haste', level: 1, effectTime: 330, condition: 1 }
                ],
                'twm:heavy_guardian_ring_witherring': [
                    { effect: 'resistance', level: 1, effectTime: 330, condition: 1 }
                ],
                'twm:heavy_runner_ring_witherring': [
                    { effect: 'speed', level: 1, effectTime: 330, condition: 1 }
                ],
                'twm:heavy_healer_ring_witherring': [
                    { effect: 'regeneration', level: 1, effectTime: 330, condition: 1 }
                ],
                'twm:heavy_miner_ring_witherring': [
                    { effect: 'haste', level: 2, effectTime: 330, condition: 1 }
                ],
                'twm:heavy_warrior_ring_witherring': [
                    { effect: 'strength', level: 1, effectTime: 330, condition: 1 }
                ],
                'twm:sacred_heart_heartycharm': [
                    { effect: 'regeneration', level: 1, effectTime: 330, condition: 1 }
                ],
                'twm:wither_heart_heartycharm': [
                    { effect: 'regeneration', level: 1, effectTime: 330, condition: 1 }
                ],
                'twm:idle_bloom_body': [
                    { effect: 'regeneration', level: 2, effectTime: 330, condition: player.getVelocity().x == 0 && player.getVelocity().y == 0 && player.getVelocity().z == 0 }
                ],
                ////////////////////////////////////////////// Archaism Talisman 
                'arena:ethereal_sight_mask_head': [
                    { effect: 'strength', level: 1, effectTime: 330, condition: player.dimension.id == 'minecraft:the_end' }
                ],
                'arena:blaze_skull_mask_head': [
                    { effect: 'strength', level: 2, effectTime: 330, condition: player.dimension.id == 'minecraft:nether' },

                    { effect: 'weakness', level: 2, effectTime: 330, condition: player.dimension.id == 'minecraft:overworld' }
                ],
                'arena:poseidon_mask_head': [
                    { effect: 'strength', level: 2, effectTime: 330, condition: headBlock.typeId.includes('water') && feetBlock?.typeId.includes('water') }
                ],
                'arena:natural_butterfly_mask_head': [
                    { effect: 'blindness', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:unnatural_mask_head': [
                    { effect: 'haste', level: 3, effectTime: 330, condition: 1 },
                    { effect: 'hunger', level: 3, effectTime: 330, condition: 1 }
                ],
                'arena:demon_mask_head': [
                    { effect: 'haste', level: 1, effectTime: 330, condition: 1 },
                    { effect: 'haste', level: 2, effectTime: 330, condition: player.hasTag('mask9_ready') },
                    { effect: 'speed', level: 1, effectTime: 330, condition: player.hasTag('mask9_ready') }
                ],
                'arena:cat_mask_head': [
                    { effect: 'weakness', level: 2, effectTime: 330, condition: !player.hasTag('light_off') },
                    { effect: 'mining_fatigue', level: 1, effectTime: 330, condition: !player.hasTag('light_off') },
                    { effect: 'jump_boost', level: 2, effectTime: 330, condition: 1 },
                    { effect: 'jump_boost', level: 3, effectTime: 330, condition: player.isSneaking },
                    { effect: 'speed', level: 1, effectTime: 330, condition: 1 },
                    { effect: 'night_vision', level: 1, effectTime: 330, condition: player.hasTag('light_off') },
                    { effect: 'invisibility', level: 1, effectTime: 330, condition: player.hasTag('light_off') && player.isSneaking }
                ],
                'arena:jump_copper_wither_ring_witherring': [
                    { effect: 'jump_boost', level: 3, effectTime: 330, condition: 1 }
                ],
                'arena:jump_iron_wither_ring_witherring': [
                    { effect: 'jump_boost', level: 4, effectTime: 330, condition: 1 }
                ],
                'arena:jump_golden_wither_ring_witherring': [
                    { effect: 'jump_boost', level: 5, effectTime: 330, condition: 1 }
                ],
                'arena:jump_prismarine_wither_ring_witherring': [
                    { effect: 'jump_boost', level: 6, effectTime: 330, condition: 1 }
                ],
                'arena:hearts_golden_wither_ring_witherring': [
                    { effect: 'mining_fatigue', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:hearts_prismarine_wither_ring_witherring': [
                    { effect: 'mining_fatigue', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:movement_golden_wither_ring_witherring': [
                    { effect: 'weakness', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:movement_prismarine_wither_ring_witherring': [
                    { effect: 'weakness', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:night_vision_gogles_talisman_talisman': [
                    { effect: 'night_vision', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:obsidian_skull_talisman_talisman': [
                    { effect: 'fire_resistance', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:rabbit_boots_talisman_talisman': [
                    { effect: 'jump_boost', level: 3, effectTime: 330, condition: 1 }
                ],
                'arena:shadow_of_nobody_talisman_talisman': [
                    { effect: 'invisibility', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:blessed_necklace_talisman_talisman': [
                    { effect: 'haste', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:hermes_boots_talisman_talisman': [
                    { effect: 'speed', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:marble_emerald_necklace_talisman_talisman': [
                    { effect: 'village_hero', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:marble_feather_talisman_talisman': [
                    { effect: 'slow_falling', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:jesus_doll_doll': [
                    { effect: 'speed', level: 1, effectTime: 330, condition: 1 },
                    { effect: 'haste', level: 1, effectTime: 330, condition: 1 },
                    { effect: 'hunger', level: 3, effectTime: 330, condition: 1 }
                ],
                'arena:masked_doll_doll': [
                    { effect: 'weakness', level: 1, effectTime: 330, condition: 1 },
                    { effect: 'haste', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:vulak_doll_doll': [
                    { effect: 'resistance', level: 1, effectTime: 330, condition: 1 },
                    { effect: 'slowness', level: 2, effectTime: 330, condition: feetBlock?.typeId.includes('water') }
                ],
                'arena:aplpha_doll_doll': [
                    { effect: 'regeneration', level: 1, effectTime: 330, condition: 1 },
                    { effect: 'mining_fatigue', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:fire_doll_doll': [
                    { effect: 'strength', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:harena_doll_doll': [
                    { effect: 'hunger', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:illuminated_doll_doll': [
                    { effect: 'saturation', level: 1, effectTime: 1, condition: 1 },
                    { effect: 'blindness', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:archaic_marble_bracelets_archaiccharm': [
                    { effect: 'strength', level: 3, effectTime: 330, condition: player.getComponent('equippable').getEquipment('Mainhand')?.typeId == 'minecraft:golden_axe' },
                    { effect: 'resistance', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:archaic_blessed_shield_archaiccharm': [
                    { effect: 'resistance', level: 3, effectTime: 330, condition: player.getComponent('equippable').getEquipment('Offhand')?.typeId == 'minecraft:shield' }
                ],
                'arena:archaic_marble_wings_archaiccharm': [
                    { effect: 'weakness', level: 2, effectTime: 330, condition: 1 },
                    { effect: 'speed', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:archaic_arnold_archaiccharm': [
                    { effect: 'poison', level: 1, effectTime: 330, condition: 1 },
                    { effect: 'hunger', level: 2, effectTime: 330, condition: 1 },
                    { effect: 'jump_boost', level: 3, effectTime: 330, condition: 1 }
                ],
                'arena:archaic_cursed_book_archaiccharm': [
                    { effect: 'regeneration', level: 3, effectTime: 330, condition: 1 },
                    { effect: 'mining_fatigue', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:archaic_cursed_skull_archaiccharm': [
                    { effect: 'strength', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:piglin_bracelet_charm_charm': [
                    { effect: 'resistance', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:prismatic_relic_charm_charm': [
                    { effect: 'conduit_power', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:marble_hand_charm_charm': [
                    { effect: 'haste', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:night_hood_charm_charm': [
                    { effect: 'resistance', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:chained_heart_talisman_talisman': [
                    { effect: 'regeneration', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:archaic_chained_soul_archaiccharm': [
                    { effect: 'speed', level: 2, effectTime: 330, condition: player.getComponent('minecraft:health').currentValue <= 6 },
                    { effect: 'resistance', level: 2, effectTime: 330, condition: player.getComponent('minecraft:health').currentValue <= 6 },
                    { effect: 'strength', level: 2, effectTime: 330, condition: player.getComponent('minecraft:health').currentValue <= 6 }
                ],
                'arena:bunny_hoppers_feet': [
                    { effect: 'jump_boost', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:running_shoes_feet': [
                    { effect: 'speed', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:digging_claws_gauntlet': [
                    { effect: 'haste', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:umbrella_gauntlet': [
                    { effect: 'slow_falling', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:a_obsidian_skull_talisman': [
                    { effect: 'fire_resistance', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:cross_necklace_necklace': [
                    { effect: 'resistance', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:regeneration_necklace_necklace': [
                    { effect: 'regeneration', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:scarf_of_invisibility_necklace': [
                    { effect: 'invisibility', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:n_drink_hat_head': [
                    { effect: 'saturation', level: 2, effectTime: 1, condition: 1 }
                ],
                'arena:a_night_vision_goggles_head': [
                    { effect: 'night_vision', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:snorkel_head': [
                    { effect: 'water_breathing', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:p_drink_hat_head': [
                    { effect: 'saturation', level: 1, effectTime: 1, condition: 1 }
                ],
                'arena:villager_hat_head': [
                    { effect: 'village_hero', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:bonnet_head': [
                    { effect: 'water_breathing', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:midnight_skull_head': [
                    { effect: 'fire_resistance', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:frog_leg_feet': [
                    { effect: 'jump_boost', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:frog_flipper_feet': [
                    { effect: 'jump_boost', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:lucky_horseshoe_feet': [
                    { effect: 'jump_boost', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:obsidian_horseshoe_feet': [
                    { effect: 'jump_boost', level: 2, effectTime: 330, condition: 1 },
                    { effect: 'fire_resistance', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:midnight_skull_head_feet': [
                    { effect: 'fire_resistance', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:band_of_regeneration_gauntlet': [
                    { effect: 'regeneration', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:ancient_chisel_gauntlet': [
                    { effect: 'haste', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:shackle_gauntlet': [
                    { effect: 'resistance', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:valentine_ring_ring': [
                    { effect: 'jump_boost', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:shiny_red_balloon_gauntlet': [
                    { effect: 'slow_falling', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:lucky_horseshoe_balloon_gauntlet': [
                    { effect: 'slow_falling', level: 1, effectTime: 330, condition: 1 },
                    { effect: 'jump_boost', level: 2, effectTime: 330, condition: 1 }
                ],
                'arena:obsidian_horseshoe_balloon_gauntlet': [
                    { effect: 'slow_falling', level: 1, effectTime: 330, condition: 1 },
                    { effect: 'jump_boost', level: 2, effectTime: 330, condition: 1 },
                    { effect: 'fire_resistance', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:jellyfish_necklace_necklace': [
                    { effect: 'conduit_power', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:discount_card_charm': [
                    { effect: 'village_hero', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:neptunes_shell_charm': [
                    { effect: 'conduit_power', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:cobalt_shield_charm': [
                    { effect: 'resistance', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:obsidian_shield_charm': [
                    { effect: 'resistance', level: 1, effectTime: 330, condition: 1 },
                    { effect: 'fire_resistance', level: 1, effectTime: 330, condition: 1 }
                ],
                'arena:ankh_shield_archaiccharm': [
                    { effect: 'resistance', level: 1, effectTime: 330, condition: 1 },
                    { effect: 'fire_resistance', level: 1, effectTime: 330, condition: 1 }
                ]
            };
            giveEffect(player, passiveEffects, player)

            if (player.hasTag('twm:repair_talisman_necklace') || player.hasTag('twm:mender_pendant_necklace')) {
                repair(player)
            }
            if (player.hasTag('arena:zultinus_doll_doll')) {
                player.runCommandAsync('effect @a[r=7] haste 10 1')
            }
            let entities = player.dimension.getEntities({ location: player.location, minDistance: 1, maxDistance: 5 })
            entities.forEach(entity => {
                if (entity?.hasComponent('minecraft:is_tamed')) {
                    if (player.hasTag('arena:iron_crown_jelewer_head')) {
                        entity.addEffect('regeneration', 100, { amplifier: 0, showParticles: true });
                    }
                    if (player.hasTag('arena:golden_crown_jelewer_head')) {
                        entity.addEffect('regeneration', 100, { amplifier: 1, showParticles: true });
                    }
                    if (player.hasTag('arena:prismarine_crown_jelewer_head')) {
                        entity.addEffect('regeneration', 100, { amplifier: 2, showParticles: true });
                    }
                    if (player.hasTag('arena:netherite_crown_jelewer_head')) {
                        entity.addEffect('regeneration', 100, { amplifier: 3, showParticles: true });
                    }
                }
                if (!entity?.hasComponent('minecraft:is_tamed')) {
                    if (player.hasTag('arena:flame_pendant_necklace')) {
                        entity.setOnFire(3);
                    }
                    if (player.hasTag('arena:demon_mask_head') && player.hasTag('mask9_ready')) {
                        entity.setOnFire(3);
                    }
                }
            })
            if (player.hasTag('arena:archaic_marble_wings_archaiccharm')) {
                player.runCommand("event entity @e[r=25,type=zombie_villager] villager_converted");
            }
            if (player.hasTag('arena:marble_rune_charm_charm')) {
                player.runCommand("execute as @s at @s if entity @e[family=monster,r=7] run effect @s slowness 10 1");
            }
            if (player.hasTag('arena:dunerider_boots_feet')) {
                player.runCommand("execute at @s as @s if block ~~-1~ sand run effect @s speed 6 1");
            }
            if (player.hasTag('arena:ice_skates_feet')) {
                player.runCommand("execute at @s as @s if block ~~-1~ ice run effect @s speed 6 1");
            }
            if (player.hasTag('arena:flower_boots_feet')) {
                player.runCommand("execute at @s as @s if block ~~-1~ grass_block run effect @s speed 6 1");
            }

        });
        // world.sendMessage(`${Date.now() - start}`)
    }, 50)
})

// Efectos que recibe el jugador pasivamente (se ejecuta cada tick, solo usar cuando es necesario)
world.afterEvents.worldInitialize.subscribe(() => {
    system.runInterval(() => {
        // We obtain all the players 
        let players = world.getAllPlayers()
        players.forEach(player => {
            if (player.hasTag('twm:lava_waders_feet')) {
                player.runCommand('function lava_waders')
            }
            if (player.hasTag('twm:cloud_steps_boots_feet')) {
                if (player.isFalling && !player.hasTag('twm:double_jumped')) {
                    if (player.isJumping) {
                        let { x, y, z } = player.getVelocity()
                        player.applyKnockback(x, z, Math.SQRT2 * Math.sqrt(x * x + z * z), 0.65)
                        player.addTag('twm:double_jumped')
                    }
                }
                if (player.isOnGround) {
                    player.removeTag('twm:double_jumped')
                }
            }
        });
    }, 1)
    system.runInterval(() => {
        // We obtain all the players 
        let players = world.getAllPlayers()
        players.forEach(player => {
            if (player.hasTag('arena:demon_mask_head') && !player.hasTag('mask9_cooldown') && !player.hasTag('mask9_ready')) {
                player.triggerEvent('minecraft:mask9_timer_on')
                player.addTag('mask9_cooldown')
            }
            if (player.hasTag('arena:demon_mask_head') && player.hasTag('mask9_ready')) {
                player.runCommandAsync('function mask9')
            }
            if (player.hasTag('arena:magnet_talisman_talisman')) {
                player.runCommandAsync('execute at @e[type=item, r=12.5] run tp @e[type=item, r=12.5] ^^^+0.5 facing @s')
            }
            if (player.hasTag('arena:cat_mask_head')) {
                player.triggerEvent('minecraft:light_level')
            }
        });
    }, 5)
})


world.afterEvents.entityDie.subscribe((e) => {
    const { deadEntity, damageSource } = e
    let attacker = damageSource.damagingEntity
    const typea = [
        "minecraft:drowned",
        "minecraft:husk",
        "minecraft:zombie",
        "minecraft:zombie_pigman",
        "minecraft:zombie_villager"
    ];
    const typeb = [
        "minecraft:agent",
        "minecraft:allay",
        "minecraft:bat",
        "minecraft:iron_golem",
        "minecraft:npc",
        "minecraft:player",
        "minecraft:snow_golem",
        "minecraft:tadpole",
        "minecraft:villager",
        "minecraft:wandering_trader"
    ];
    const typec = [
        "minecraft:blaze",
        "minecraft:elder_guardian",
        "minecraft:evoker",
        "minecraft:guardian",
        "minecraft:enderman"
    ];
    const typed = [
        "minecraft:piglin_brute",
        "minecraft:ravager"
    ];
    if (attacker?.typeId == 'minecraft:player') {
        if (attacker.hasTag('arena:rhetoric_skull_talisman')) {
            attacker.addEffect('poison', 50, { amplifier: 3, showParticles: true })
        }
        if (attacker.hasTag('arena:archaic_arnold_archaiccharm')) {
            if (!deadEntity.hasComponent('minecraft:is_baby') && !typea.includes(deadEntity.typeId) && !typeb.includes(deadEntity.typeId) && !typec.includes(deadEntity.typeId) && !typed.includes(deadEntity.typeId) && deadEntity.typeId != "minecraft:ender_dragon" && deadEntity.typeId != "minecraft:wither") {
                attacker.runCommand("xp 5 @s");
            } else if ((deadEntity.hasComponent('minecraft:is_baby') && typea.includes(deadEntity.typeId)) || typec.includes(deadEntity.typeId)) {
                attacker.runCommand("xp 10 @s");
            } else if (typed.includes(deadEntity.typeId)) {
                attacker.runCommand("xp 200 @s");
            } else if (deadEntity.typeId == "minecraft:wither") {
                attacker.runCommand("xp 500 @s");
            } else if (deadEntity.typeId == "minecraft:ender_dragon") {
                attacker.runCommand("xp 500 @s");
            }
        }
        if (attacker.hasTag('arena:golden_hook_gauntlet')) {
            if (!deadEntity.hasComponent('minecraft:is_baby') && !typea.includes(deadEntity.typeId) && !typeb.includes(deadEntity.typeId) && !typec.includes(deadEntity.typeId) && !typed.includes(deadEntity.typeId) && deadEntity.typeId != "minecraft:ender_dragon" && deadEntity.typeId != "minecraft:wither") {
                attacker.runCommand("xp 2 @s");
            } else if ((deadEntity.hasComponent('minecraft:is_baby') && typea.includes(deadEntity.typeId)) || typec.includes(deadEntity.typeId)) {
                attacker.runCommand("xp 5 @s");
            } else if (typed.includes(deadEntity.typeId)) {
                attacker.runCommand("xp 100 @s");
            } else if (deadEntity.typeId == "minecraft:wither") {
                attacker.runCommand("xp 250 @s");
            } else if (deadEntity.typeId == "minecraft:ender_dragon") {
                attacker.runCommand("xp 250 @s");
            }
        }
        if (attacker.hasTag('arena:doble_edged_charm')) {
            let kills = attacker.getDynamicProperty('doble_edged_kills')
            if (kills) {
                kills += 1
                attacker.setDynamicProperty('doble_edged_kills', kills)
            } else {
                attacker.setDynamicProperty('doble_edged_kills', 1)
            }
        }
    }
})

// Inmunidades a efectos (no evita el daño, simplemente el efecto es cancelado antes de recibirlo)
world.beforeEvents.effectAdd.subscribe(e => {
    const tagImmunities = {
        'twm:bezoar_charm': ['Poison'],
        'twm:wither_heart_heartycharm': ['Wither'],
        'twm:warden_heart_heartycharm': ['Darkness', 'Blindness'],
        'twm:night_vision_mask_head': ['Darkness', 'Blindness'],
        'twm:soul_heart_heartycharm': ['Darkness'],
        'twm:eternal_heart_heartycharm': ['Poison', 'Wither', 'Hunger'],
        'twm:blood_pact_archaiccharm': ['Regeneration'],
        ///////////////////////////////////
        'arena:poseidon_mask_head': ['Mining Fatigue'],
        'arena:kitsume_mask_head': ['Regeneration', 'Resistance', 'Strength', 'Speed', 'Jump Boost', 'Health Boost', 'Absortion', 'Fire Resistance'],
        'arena:withered_ring_jelewer_ring': ['Wither'],
        'arena:silk_ring_jelewer_ring': ['Poison'],
        'arena:shulked_ring_jelewer_ring': ['Levitation'],
        'arena:shadow_step_ring_jelewer_ring': ['Slowness'],
        'arena:obsidian_ring_jelewer_ring': ['Mining Fatigue'],
        'arena:crimson_ring_jelewer_ring': ['Weakness'],
        'arena:crimsom_amethyst_ring_jelewer_ring': ['Hunger'],
        'arena:blinding_of_shinning_ring_jelewer_ring': ['Blindness'],
        'arena:nefrite_bracelet_talisman_talisman': ['Weakness', 'Mining Fatigue'],
        'arena:shulked_doll_doll': ['Strength'],
        'arena:bee_doll_doll': ['Speed'],
        'arena:archaic_incript_paper_archaiccharm': ['Darkness'],
        'arena:nefrite_crow_charm_charm': ['Poison', 'Wither', 'Hunger'],
        'arena:blindfold_head': ['Darkness', 'Blindness'],
        'arena:phantom_eye_head': ['Darkness'],
        'arena:midnight_skull_head': ['Darkness'],
        'arena:bezoar_talisman': ['Poison'],
        'arena:adhesive_bandage_talisman': ['Wither'],
        'arena:fast_clock_talisman': ['Slowness'],
        'arena:chorus_heart_talisman': ['Levitation'],
        'arena:forbidden_fruit_talisman': ['Hunger'],
        'arena:vitamins_talisman': ['Weakness', 'Mining Fatigue'],
        'arena:medicated_bandage_talisman': ['Wither', 'Poison'],
        'arena:chorus_clock_talisman': ['Slowness', 'Levitation'],
        'arena:ankh_charm_archaiccharm': ['Poison', 'Wither', 'Slowness', 'Mining Fatigue', 'Darkness', 'Blindness', 'Hunger', 'Levitation', 'Weakness'],
        'arena:ankh_shield_archaiccharm': ['Poison', 'Wither', 'Slowness', 'Mining Fatigue', 'Darkness', 'Blindness', 'Hunger', 'Levitation', 'Weakness']

    };

    const { effectType, entity } = e;
    if (entity.typeId !== 'minecraft:player') return;

    for (const [tag, effects] of Object.entries(tagImmunities)) {
        if (entity.hasTag(tag) && effects.some(effect => effectType.includes(effect))) {
            e.duration = -1;
        }
    }
})



// Se ejecuta al golpear a una entidad
world.afterEvents.entityHurt.subscribe(e => {
    const { hurtEntity, damageSource, damage } = e
    const undead = [
        "minecraft:bogged",
        "minecraft:drowned",
        "minecraft:husk",
        "minecraft:phantom",
        "minecraft:skeleton",
        "minecraft:skeleton_horse",
        "minecraft:stray",
        "minecraft:wither_skeleton",
        "minecraft:zoglin",
        "minecraft:zombie",
        "minecraft:zombie_horse",
        "minecraft:zombie_pigman",
        "minecraft:zombie_villager"
    ];
    const guardians = [
        "minecraft:elder_guardian",
        "minecraft:guardian"
    ];
    let attacker = damageSource.damagingEntity
    if (attacker?.typeId == 'minecraft:player') {
        // Effects list
        // effect: is the name of the effect
        // condition: if it needs an external condition or even having another tag (for doing sets)
        // If the trinket doesnt need any conditions, write 1 or True
        // level: the level of the given effect

        // Tag = item identifier + slot
        const activeEffects = {
            'arena:handwarmer_gauntlet': [
                { effect: 'slowness', level: 1, condition: damageSource.cause != 'projectile', effectTime: 120 }
            ],
            'twm:ice_gauntlet_gauntlet': [
                { effect: 'slowness', level: 1, condition: damageSource.cause != 'projectile', effectTime: 120 }
            ],
            'twm:venom_gauntlet_gauntlet': [
                { effect: 'poison', level: 1, condition: damageSource.cause != 'projectile', effectTime: 120 }
            ],
            'twm:ice_claw_gauntlet': [
                { effect: 'slowness', level: 1, condition: damageSource.cause != 'projectile', effectTime: 120 }
            ],
            'twm:venom_claw_gauntlet': [
                { effect: 'poison', level: 1, condition: damageSource.cause != 'projectile', effectTime: 120 }
            ],
            'twm:frost_quiver_body': [
                { effect: 'slowness', level: 1, condition: damageSource.cause == 'projectile', effectTime: 120 }
            ],
            'twm:venom_quiver_body': [
                { effect: 'poison', level: 1, condition: damageSource.cause == 'projectile', effectTime: 120 }
            ],
            //////////////////////
            'arena:natural_butterfly_mask_head': [
                { effect: 'wither', level: 4, condition: 1, effectTime: 120 }
            ],
            'arena:amethyst_earring_jelewer_ring': [
                { effect: 'slowness', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:crimsom_earring_jelewer_ring': [
                { effect: 'poison', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:crimsom_amethyst_earring_jelewer_ring': [
                { effect: 'weakness', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:iron_end_necklace_jelewer_necklace': [
                { effect: 'levitation', level: 1, condition: 1, effectTime: 3 }
            ],
            'arena:iron_fire_necklace_jelewer_necklace': [
                { effect: 'weakness', level: 2, condition: 1, effectTime: 180 }
            ],
            'arena:iron_poison_necklace_jelewer_necklace': [
                { effect: 'poison', level: 2, condition: 1, effectTime: 180 }
            ],
            'arena:iron_snow_necklace_jelewer_necklace': [
                { effect: 'slowness', level: 2, condition: 1, effectTime: 180 }
            ],
            'arena:golden_end_necklace_jelewer_necklace': [
                { effect: 'levitation', level: 2, condition: 1, effectTime: 120 }
            ],
            'arena:golden_fire_necklace_jelewer_necklace': [
                { effect: 'weakness', level: 3, condition: 1, effectTime: 240 }
            ],
            'arena:golden_poison_necklace_jelewer_necklace': [
                { effect: 'poison', level: 3, condition: 1, effectTime: 240 }
            ],
            'arena:golden_snow_necklace_jelewer_necklace': [
                { effect: 'slowness', level: 3, condition: 1, effectTime: 240 }
            ],
            'arena:prismarine_end_necklace_jelewer_necklace': [
                { effect: 'levitation', level: 3, condition: 1, effectTime: 150 }
            ],
            'arena:prismarine_fire_necklace_jelewer_necklace': [
                { effect: 'weakness', level: 4, condition: 1, effectTime: 300 }
            ],
            'arena:prismarine_poison_necklace_jelewer_necklace': [
                { effect: 'poison', level: 4, condition: 1, effectTime: 300 }
            ],
            'arena:prismarine_snow_necklace_jelewer_necklace': [
                { effect: 'slowness', level: 4, condition: 1, effectTime: 300 }
            ],
            'arena:netherite_end_necklace_jelewer_necklace': [
                { effect: 'levitation', level: 4, condition: 1, effectTime: 150 }
            ],
            'arena:netherite_fire_necklace_jelewer_necklace': [
                { effect: 'weakness', level: 5, condition: 1, effectTime: 360 }
            ],
            'arena:netherite_poison_necklace_jelewer_necklace': [
                { effect: 'poison', level: 5, condition: 1, effectTime: 360 }
            ],
            'arena:netherite_snow_necklace_jelewer_necklace': [
                { effect: 'slowness', level: 5, condition: 1, effectTime: 360 }
            ],
            'arena:archaic_chained_soul_archaiccharm': [
                { effect: 'wither', level: 1, condition: attacker.getComponent('minecraft:health').currentValue <= 6, effectTime: 120 }
            ]
        };
        // Estos hacen cosas diferentes a efectos 
        if (attacker.hasTag('arena:blaze_skull_mask_head') && damageSource.cause != 'projectile') {
            hurtEntity.setOnFire(3)
        }
        if (attacker.hasTag('arena:fire_gauntlet_gauntlet') && damageSource.cause != 'projectile') {
            hurtEntity.setOnFire(3)
        }
        if (attacker.hasTag('twm:fire_claw_gauntlet') && damageSource.cause != 'projectile') {
            hurtEntity.setOnFire(3)
        }
        if (attacker.hasTag('twm:molten_quiver_body') && damageSource.cause == 'projectile') {
            hurtEntity.setOnFire(3)
        }
        if (attacker.hasTag('arena:demon_mask_head') && attacker.hasTag('mask9_ready')) {
            hurtEntity.applyDamage(damage * 2)
            attacker.removeTag('mask9_ready')
        }
        if (attacker.hasTag('arena:iron_fire_necklace_jelewer_necklace')) {
            hurtEntity.setOnFire(3)
            if (2 >= Math.ceil(Math.random() * 100)) {
                hurtEntity.applyDamage(damage * 0.5)
            }
        }
        if (attacker.hasTag('arena:iron_end_necklace_jelewer_necklace') && 4 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:iron_light_necklace_jelewer_necklace') && 8 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 1)
        }
        if (attacker.hasTag('arena:iron_snow_necklace_jelewer_necklace') && 4 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:golden_fire_necklace_jelewer_necklace')) {
            hurtEntity.setOnFire(3)
            if (4 >= Math.ceil(Math.random() * 100)) {
                hurtEntity.applyDamage(damage * 0.5)
            }
        }
        if (attacker.hasTag('arena:golden_end_necklace_jelewer_necklace') && 8 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:golden_light_necklace_jelewer_necklace') && 16 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 1)
        }
        if (attacker.hasTag('arena:golden_snow_necklace_jelewer_necklace') && 8 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:prismarine_fire_necklace_jelewer_necklace')) {
            hurtEntity.setOnFire(3)
            if (6 >= Math.ceil(Math.random() * 100)) {
                hurtEntity.applyDamage(damage * 0.5)
            }
        }
        if (attacker.hasTag('arena:prismarine_end_necklace_jelewer_necklace') && 12 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:prismarine_light_necklace_jelewer_necklace') && 24 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 1)
        }
        if (attacker.hasTag('arena:prismarine_snow_necklace_jelewer_necklace') && 16 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:netherite_fire_necklace_jelewer_necklace')) {
            hurtEntity.setOnFire(3)
            if (8 >= Math.ceil(Math.random() * 100)) {
                hurtEntity.applyDamage(damage * 0.5)
            }
        }
        if (attacker.hasTag('arena:netherite_end_necklace_jelewer_necklace') && 16 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:netherite_light_necklace_jelewer_necklace') && 32 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 1)
        }
        if (attacker.hasTag('arena:netherite_snow_necklace_jelewer_necklace') && 16 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:archaic_marble_wings_archaiccharms') && undead.includes(hurtEntity?.typeId) && attacker.getComponent('equippable').getEquipment('Chest')?.typeId == 'minecraft:elytra') {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:archaic_incript_paper_archaiccharm') && 25 >= Math.ceil(Math.random() * 100)) {
            attacker.addEffect('absorption', 120, { amplifier: 0, showParticles: false });
        }
        if (attacker.hasTag('arena:archaic_light_cepter_archaiccharm') && 5 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 1.5)
        }
        if (attacker.hasTag('arena:archaic_light_cepter_archaiccharm') && 35 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.runCommand('execute as @s at @s run summon lightning_bolt ~ ~ ~');
        }
        if (attacker.hasTag('arena:light_necklace_necklace') && 10 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.runCommand('execute as @s at @s run summon lightning_bolt ~ ~ ~');
        }
        if (attacker.hasTag('arena:blessed_skull_charm_charm') && 15 >= Math.ceil(Math.random() * 100)) {
            attacker.addEffect('instant_health', 1, { amplifier: 0, showParticles: true })
        }
        if (attacker.hasTag('arena:vampic_glove_gauntlet') && 10 >= Math.ceil(Math.random() * 100)) {
            attacker.addEffect('regeneration', 3, { amplifier: 20, showParticles: true })
        }
        if (attacker.hasTag('arena:poseidon_mask_head')) {
            if (guardians.includes(hurtEntity?.typeId)) {
                hurtEntity.applyDamage(damage * 0.8)
            }
        }
        if (attacker.hasTag('arena:doble_edged_charm')) {
            let kills = attacker.getDynamicProperty('doble_edged_kills')
            if (kills >= 12) {
                hurtEntity.applyDamage(damage * 0.4)
                hurtEntity.setOnFire(3)
                attacker.setDynamicProperty('doble_edged_kills', 0)
            }
        }
        if (attacker.hasTag('twm:blood_pact_archaiccharm')) {
            let health = attacker.getComponent('minecraft:health').currentValue
            attacker.getComponent('minecraft:health').setCurrentValue(health + damage * 0.12)
        }
        if (attacker.hasTag('twm:bloodbound_amulet_talisman')) {
            let health = attacker.getComponent('minecraft:health').currentValue
            attacker.getComponent('minecraft:health').setCurrentValue(health + damage * 0.06)
        }
        if (attacker.hasTag('twm:blood_pendant_necklace')) {
            let health = attacker.getComponent('minecraft:health').currentValue
            attacker.getComponent('minecraft:health').setCurrentValue(health + damage * 0.02)
        }
        if (attacker.hasTag('twm:holy_cross_talisman')) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        giveEffect(attacker, activeEffects, hurtEntity)
    }
    if (hurtEntity?.typeId == 'minecraft:player') {

        // Effects list
        // effect: is the name of the effect
        // condition: if it needs an external condition or even having another tag (for doing sets)
        // If the trinket doesnt need any conditions, write 1 or True
        // level: the level of the given effect

        // Tag = item identifier + slot
        const activeEffects = {
            'arena:amethyst_earring_jelewer_ring': [
                { effect: 'slowness', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:crimsom_earring_jelewer_ring': [
                { effect: 'poison', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:crimsom_amethyst_earring_jelewer_ring': [
                { effect: 'weakness', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:unnatural_mask_head': [
                { effect: 'wither', level: 4, condition: 1, effectTime: 120 }
            ]
        }
        if (hurtEntity.hasTag('arena:blaze_skull_mask_head')) {
            attacker.setOnFire(3)
        }
        if (hurtEntity.hasTag('arena:death_skull_talisman_talisman')) {
            attacker.applyDamage(damage * 0.25)
        }
        if (hurtEntity.hasTag('arena:thorn_pendant_necklace')) {
            attacker.applyDamage(damage * 0.25)
        }
        if (hurtEntity.hasTag('arena:archaic_blessed_shield_archaiccharm') && 15 >= Math.ceil(Math.random() * 100)) {
            attacker.applyDamage(damage * 2)
        }
        if (hurtEntity.hasTag('arena:archaic_incript_paper_archaiccharm')) {
            attacker.runCommandAsync(`xp ${Math.floor(damage * 0.25)}`)
        }
        if (hurtEntity.hasTag('twm:rush_of_fear_necklace') && !hurtEntity.hasTag('rush_of_fear_on')) {
            hurtEntity.addTag('rush_of_fear_on')
            abilities(hurtEntity)
            system.runTimeout(() => {
                hurtEntity.removeTag('rush_of_fear_on')
                abilities(hurtEntity)
            }, 40)
        }
        if (hurtEntity.hasTag('arena:ethereal_sight_mask_head')) {
            hurtEntity.runCommandAsync('function mask_tp')
        }
        if (hurtEntity.hasTag('arena:obsidian_eye_talisman_talisman') && 25 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.runCommandAsync('function evasion')
        }
        giveEffect(hurtEntity, activeEffects, attacker)
    }
})

world.afterEvents.playerBreakBlock.subscribe(e => {
    const { brokenBlockPermutation, player, block } = e;

    if (!player.hasTag("arena:lucky_scarf_necklace")) return;

    const blockDrops = {
        "minecraft:coal_ore": { item: "minecraft:coal" },
        "minecraft:deepslate_coal_ore": { item: "minecraft:coal" },
        "minecraft:copper_ore": { item: "minecraft:raw_copper" },
        "minecraft:deepslate_copper_ore": { item: "minecraft:raw_copper" },
        "minecraft:iron_ore": { item: "minecraft:raw_iron" },
        "minecraft:deepslate_iron_ore": { item: "minecraft:raw_iron" },
        "minecraft:gold_ore": { item: "minecraft:raw_gold" },
        "minecraft:deepslate_gold_ore": { item: "minecraft:raw_gold" },
        "minecraft:lapis_ore": { item: "minecraft:lapis_lazuli" },
        "minecraft:deepslate_lapis_ore": { item: "minecraft:lapis_lazuli" },
        "minecraft:redstone_ore": { item: "minecraft:redstone" },
        "minecraft:lit_redstone_ore": { item: "minecraft:redstone" },
        "minecraft:deepslate_redstone_ore": { item: "minecraft:redstone" },
        "minecraft:lit_deepslate_redstone_ore": { item: "minecraft:redstone" },
        "minecraft:diamond_ore": { item: "minecraft:diamond" },
        "minecraft:deepslate_diamond_ore": { item: "minecraft:diamond" },
        "minecraft:emerald_ore": { item: "minecraft:emerald" },
        "minecraft:deepslate_emerald_ore": { item: "minecraft:emerald" },
        "minecraft:nether_gold_ore": { item: "minecraft:gold_nugget", min: 3, max: 3 },
        "minecraft:quartz_ore": { item: "minecraft:quartz" }
    };

    let blockTypeId = brokenBlockPermutation?.type?.id;
    let location = block?.location;

    if (blockTypeId in blockDrops) {
        let { item, min, max } = blockDrops[blockTypeId];
        let amount = (min !== undefined && max !== undefined)
            ? Math.floor(Math.random() * (max - min + 1)) + min
            : 1;
        let itemStack = new ItemStack(item, amount);
        player.dimension.spawnItem(itemStack, location);
    }
})



//////////////////////////////////////////////////////////////////////////////////////////////////// Funciones (Ignorar)

// Funcion de reparar
function repair(player) {
    let equippable = player.getComponent('equippable')
    let equipmentSet = ['Mainhand']
    if (player.hasTag('twm:mender_pendant_necklace')) equipmentSet.push('Head', 'Chest', 'Legs', 'Feet', 'Offhand')
    for (let equipment of equipmentSet) {
        const item = equippable.getEquipment(equipment)
        if (item != undefined) {
            const durability = item.getComponent('minecraft:durability')
            if (item.hasComponent('minecraft:durability') && durability.damage != 0) {
                durability.damage = Math.max(durability.damage - 1)
                equippable.setEquipment(equipment, item)
            }
        }
    }
}

function giveEffect(player, tags, entity) {
    let effects = {};
    let effectTimes = {}; // Almacenar tiempos de cada efecto

    for (const [tag, effectList] of Object.entries(tags)) {
        if (!player.hasTag(tag)) continue;

        effectList.forEach(({ effect, condition, level, effectTime }) => {
            if (condition) {
                // Suma niveles correctamente y actualiza tiempos
                effects[effect] = (effects[effect] || 0) + level; // Suma niveles directamente
                effectTimes[effect] = Math.max(effectTimes[effect] || 0, effectTime);
            }
        });
    }

    // Manejo de efectos en conflicto
    const conflictingEffects = [
        { effect1: 'poison', effect2: 'regeneration' },
        { effect1: 'weakness', effect2: 'strength' },
        { effect1: 'mining_fatigue', effect2: 'haste' },
        { effect1: 'slowness', effect2: 'speed' }
    ];

    conflictingEffects.forEach(({ effect1, effect2 }) => {
        const level1 = effects[effect1] || 0;
        const level2 = effects[effect2] || 0;

        if (level1 > 0 && level2 > 0) {
            if (level1 === level2) {
                // Si los niveles son iguales, ambos se cancelan
                delete effects[effect1];
                delete effects[effect2];
                delete effectTimes[effect1];
                delete effectTimes[effect2];
            } else {
                // Mantiene el efecto más fuerte
                const strongerEffect = level1 > level2 ? effect1 : effect2;
                const weakerEffect = level1 > level2 ? effect2 : effect1;
                effects[strongerEffect] = Math.abs(level1 - level2);
                delete effects[weakerEffect];
                delete effectTimes[weakerEffect];
            }
        }
    });

    // Aplica los efectos al jugador con los tiempos correctos
    for (const [effectName, level] of Object.entries(effects)) {
        const time = effectTimes[effectName] || 0; // Tiempo correspondiente
        entity.addEffect(effectName, time, { amplifier: level - 1, showParticles: false }); // Amplificador comienza en 0
    }
}
// Esta funcion cambia las stats del jugador automaticamente (no es necesario modificar nada)
function abilities(source) {
    const tags = source.getTags();
    let maskTagPresent = false;
    let temp = source.hasTag('rush_of_fear_on') * 0.1
    const initialValues = {
        health: 20,      // Valor inicial de vida
        speed: 0.1 + temp,      // Valor inicial de velocidad
        attack: 1,       // Valor inicial de ataque
        waterSpeed: 0.02,// Velocidad en agua
        magicD: 1,       // Protección mágica
    };

    const minValues = {
        health: 2,       // Mínimo de vida
        speed: 0.05,     // Mínimo de velocidad
        attack: 1,       // Mínimo de ataque
        waterSpeed: 0.002,   // Mínimo de velocidad en agua
        magicD: 0.05,       // Mínimo de protección mágica
    };

    const accumulatedProperties = { ...initialValues };

    // Iterar sobre los tags
    for (let tag of tags) {
        if (tag.includes('mask')) {
            maskTagPresent = true;
        }

        const identifier = tag.slice(0, tag.lastIndexOf('_'));
        const trinket = trinkets.find(x => x.identifier === identifier);

        Object.keys(initialValues).forEach(prop => {
            if (tag.startsWith(prop)) {
                source.removeTag(tag);
            }
        });

        if (trinket) {
            Object.keys(initialValues).forEach(prop => {
                if (trinket[prop] !== undefined) {
                    accumulatedProperties[prop] += trinket[prop];
                    accumulatedProperties[prop] = Math.round(accumulatedProperties[prop] * 100) / 100;
                }
            });
        }
    }

    Object.keys(accumulatedProperties).forEach(prop => {
        accumulatedProperties[prop] = Math.max(accumulatedProperties[prop], minValues[prop]);
    });

    Object.entries(accumulatedProperties).forEach(([prop, value]) => {
        source.triggerEvent(`minecraft:${prop}${value}`);
        source.addTag(`${prop}${value}`);
    });

    let event = undefined;

    // Manejo de máscaras
    for (const [tag, events] of Object.entries(eventPlayer)) {
        if (source.hasTag(tag)) {
            event = events.on;
        } else {
            events.off.forEach(event => source.triggerEvent(event));
        }
    }

    if (event) {
        event.forEach(event => source.triggerEvent(event));
    }

    if (!maskTagPresent) {
        source.triggerEvent('minecraft:event_mask0');
    }
    if (!source.hasTag('arena:doble_edged_charm')) {
        source.setDynamicProperty('doble_edged_kills', 0)
    }
    if (source.hasTag('twm:blood_pact_archaiccharm')) {
        source.runCommandAsync('effect @s clear regeneration')
    }
}



export { trinkets, abilities }
